#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *mon[13]= { "","Jaenner","Februar","Maerz","April",
		    "Mai","Juni","Juli","August",
		    "September","Oktober","November","Dezember" };


/* gibt Wochentag zurck                             */
/* 1  = Sonntag, 2 = Montag, ... , 7 = Samstag       */
/* 0  = Datum ungltig z.B. 29.2.2007, 32.12.2007    */
/* -1 = Jahr kleiner als 1583 oder grer als 9999   */

int dayofweek(int d, int m, int y)

{ 
  int s=0, mtag[13]={0,31,28,31,30,31,30,31,31,30,31,30,31}; 
  if ((y % 4==0 && y % 100!=0) || y % 400==0) s=1; 
  if (y<1583 || y>9999) return(-1); 
  if (m<1 || m>12) return(0);
  if (d<1 || d>mtag[m]+s*(m==2)) return(0); 
  if (m < 3) { m += 13; y--; } else  m++; 
  s = d + 26*m/10 + y + y/4 - y/100 + y/400 + 6; 
  return(s % 7 + 1); 
}

/* Alte Version */
/*

int dayofweek(int d,int m,int y)

{
  int mtag[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
  int s=0,k,l,o,t,z1,z2,z3,z4,z5,z6;
  double p,z;
  if (y % 4==0)   s=1;
  if (y % 100==0) s=0;
  if (y % 400==0) s=1;
  if (s) mtag[2]=29;
  if (y<1753 || y>9999) return(-1);
  if (m<1 || m>12)      return(0);
  if (d<1 || d>mtag[m]) return(0);
  z=(0.6+(1.0/m));
  k=(int) z;
  l=y-k;
  o=m+12*k;
  p=l/100.0;
  z=p/4.0;
  z1=(int) z;
  z2=(int) p;
  z=(5.0*l)/4.0;
  z3=(int) z;
  z=(13.0*(o+1)/5.0);
  z4=(int) z;
  z5=z4+z3-z2+z1+d-1;
  z=z5/7.0;
  z6=(int) z;
  t=z5-(7*z6)+1;
  return(t);
}

*/

int main(argc, argv)
char *argv[];
int  argc;
{
  int i,j,r=0,s,t=0,monat,jahr;
  if (argc<3)
  {
    printf("\n\n     Dieses Programm gibt einen Kalender aus");
    printf("\n     Aufruf mit %s Monat Jahr",argv[0]);
    printf("\n     oder   mit %s Monat Jahr /x",argv[0]);
    printf("\n     dann beginnt der Kalender mit Montag");
    printf("\n\n");     
    exit(1);
  }
  jahr=atoi(argv[2]);
  if (jahr>=0   && jahr<=40) jahr+=2000;
  if (jahr>=41  && jahr<=99) jahr+=1900;
  if (jahr<1583 || jahr>9999)
  {
    printf("\n\n     Das Jahr mu im Bereich von 1583 bis 9999 sein!\n\n");
    exit(1);
  }
  monat=atoi(argv[1]);
  if (monat<1 || monat>12)
  {
    printf("\n\n     Das Monat mu im Bereich von 1 bis 12 sein!\n\n");
    exit(1);
  }
  if (argc>3) r=1;
  printf("\n  %s %d",mon[monat],jahr);
  if (r)
    printf("\n\n  Mo  Di  Mi  Do  Fr  Sa  So\n");
  else
    printf("\n\n  So  Mo  Di  Mi  Do  Fr  Sa\n");
  for (i=1; i<32; i++)
  {
    s=dayofweek(i,monat,jahr);
    if (r)
    {
      if (s>0)
      {
        s--;
        if (s==0) s=7;
      }
    }
    if (s)
    {
      if (t==0)
      {
        printf(" ");
        for (j=1; j<s; j++)
          printf("    ");
        t=1;
      }
      printf(" %2d ",i);
      if (s==7) printf("\n ");
    }
  }
  printf("\n");
  if (jahr<1753)
    printf("\n  Nicht fuer alle Laender gueltig!\n");
  if (jahr>2799)
    printf("\n  Vorbehaltlich einer Kalenderreform!\n");
  printf("\n");
  exit(0);
  return(0);
}
