#include <stdio.h>
#include <string.h>
#include <stdlib.h>

char *mon[13]= { "","Jnner","Februar","Mrz","April",
		    "Mai","Juni","Juli","August",
		    "September","Oktober","November","Dezember" };

char *woch[8]= { "ungltiger Tag","Sonntag","Montag","Dienstag","Mittwoch",
                 "Donnerstag","Freitag","Samstag" };



/* gibt Wochentag zurck                             */
/* 1  = Sonntag, 2 = Montag, ... , 7 = Samstag       */
/* 0  = Datum ungltig z.B. 29.2.2007, 32.12.2007    */
/* -1 = Jahr kleiner als 1583 oder grer als 9999   */

int dayofweek(int d, int m, int y)

{ 
  int s=0, mtag[13]={0,31,28,31,30,31,30,31,31,30,31,30,31}; 
  if ((y % 4==0 && y % 100!=0) || y % 400==0) s=1; 
  if (y<1583 || y>9999) return(-1); 
  if (m<1 || m>12) return(0);
  if (d<1 || d>mtag[m]+s*(m==2)) return(0); 
  if (m < 3) { m += 13; y--; } else  m++; 
  s = d + 26*m/10 + y + y/4 - y/100 + y/400 + 6; 
  return(s % 7 + 1); 
}

/* Alte Version */
/*

int dayofweek(int d,int m,int y)

{
  int mtag[13]={0,31,28,31,30,31,30,31,31,30,31,30,31};
  int s=0,k,l,o,t,z1,z2,z3,z4,z5,z6;
  double p,z;
  if (y % 4==0)   s=1;
  if (y % 100==0) s=0;
  if (y % 400==0) s=1;
  if (s) mtag[2]=29;
  if (y<1753 || y>9999) return(-1);
  if (m<1 || m>12)      return(0);
  if (d<1 || d>mtag[m]) return(0);
  z=(0.6+(1.0/m));
  k=(int) z;
  l=y-k;
  o=m+12*k;
  p=l/100.0;
  z=p/4.0;
  z1=(int) z;
  z2=(int) p;
  z=(5.0*l)/4.0;
  z3=(int) z;
  z=(13.0*(o+1)/5.0);
  z4=(int) z;
  z5=z4+z3-z2+z1+d-1;
  z=z5/7.0;
  z6=(int) z;
  t=z5-(7*z6)+1;
  return(t);
}

*/

int main(argc, argv)
char *argv[];
int  argc;
{
  int s,tag,monat,jahr;
  if (argc<4)
  {
    printf("\n\n     Dieses Programm ermittelt den Wochentag");
    printf("\n     Aufruf mit %s Tag Monat Jahr",argv[0]);
    printf("\n\n");     
    exit(1);
  }
  jahr=atoi(argv[3]);
  if (jahr<1583 || jahr>9999)
  {
    printf("\n\n     Das Jahr mu im Bereich von 1583 bis 9999 sein!\n\n");
    exit(1);
  }
  monat=atoi(argv[2]);
  if (monat<1 || monat>12)
  {
    printf("\n\n     Das Monat mu im Bereich von 1 bis 12 sein!\n\n");
    exit(1);
  }
  tag=atoi(argv[1]);
  if (tag<1 || tag>31)
  {
    printf("\n\n     Der Tag mu im Bereich von 1 bis 31 sein!\n\n");
    exit(1);
  }
  s=dayofweek(tag,monat,jahr);
  printf("\n\n     Der %d. %s %d ist ein %s.\n\n",tag,mon[monat],jahr,woch[s]);
  exit(0);
  return(0);
}
